package org.ajax4jsf.bean;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;

import org.ajax4jsf.context.AjaxContext;
import org.ajax4jsf.context.AjaxContextImpl;

import com.sun.faces.context.FacesContextImpl;

public class A4JCommandTestBean {
	
	private String value;
	
	private boolean rendered = true;
	
	private AjaxContext getAjaxContext () {
		FacesContext context = FacesContextImpl.getCurrentInstance();
		if (context != null) {
			return AjaxContextImpl.getCurrentInstance(context); 
		}
		return null;
	}
	
	@SuppressWarnings("unchecked")
	private void put2ResponseData(String key, Object value) {
		AjaxContext ajaxContext = getAjaxContext();
		if (ajaxContext != null) {
			Map<String, Object> data = (Map<String, Object>)ajaxContext.getResponseData();
			if (null == data) {
				data = new HashMap<String, Object>();
				ajaxContext.setResponseData(data);
			}
			data.put(key, value);
		}
	}
	
	public String action () {
		put2ResponseData("action", true);
		return null;
	}
	
	public void actionListener (ActionEvent event) {
		put2ResponseData("actionListener", true);
	}

	/**
	 * @return the value
	 */
	public String getValue() {
		return value;
	}

	/**
	 * @param value the value to set
	 */
	public void setValue(String value) {
		this.value = value;
		put2ResponseData("input", true);
	}
	
	public boolean isRendered() {
		return rendered;
	}
	
	public String reRender(){
		this.setRendered(!rendered);
		return null;
	}

	/**
	 * @param value the value to set
	 */
	public void setRendered(boolean rendered) {
		this.rendered = rendered;
	}
	
	public String getDate () {
		return String.valueOf(Math.random());
	}

}
